/*	DeciDigit module
	takes a binary num[17:0] wire and displays,
	in decimal, the decimal equivalent number on
	the seven-segment displays

*/
module DeciDigit(HEX0, HEX1, HEX2, HEX3, HEX4, HEX5, HEX6, HEX7, num);
	output [6:0] HEX0, HEX1, HEX2, HEX3, HEX4, HEX5, HEX6, HEX7;
	input [17:0] num;
	reg [17:0] iHEX0num, iHEX1num, iHEX2num, iHEX3num, iHEX4num, iHEX5num, iHEX6num, iHEX7num;
	
	HexDigit Digit0(HEX0, iHEX0num[3:0]);
	HexDigit Digit1(HEX1, iHEX1num[3:0]);
	HexDigit Digit2(HEX2, iHEX2num[3:0]);
	HexDigit Digit3(HEX3, iHEX3num[3:0]);
	HexDigit Digit4(HEX4, iHEX4num[3:0]);
	HexDigit Digit5(HEX5, iHEX5num[3:0]);
	HexDigit Digit6(HEX6, iHEX6num[3:0]);
	HexDigit Digit7(HEX7, iHEX7num[3:0]);

	always @(num) begin
		iHEX0num <= num%10;
		iHEX1num <= (num)/10 % 10;
		iHEX2num <= (num)/100 % 10;
		iHEX3num <= (num)/1000 % 10;
		iHEX4num <= (num)/10000 % 10;
		iHEX5num <= (num)/100000 % 10;
		iHEX6num <= (num)/1000000 % 10;
		iHEX7num <= (num)/10000000 % 10;
	end
endmodule

module Deci4Digit(HEX0, HEX1, HEX2, HEX3, num);
	output [6:0] HEX0, HEX1, HEX2, HEX3;
	input [17:0] num;
	reg [17:0] iHEX0num, iHEX1num, iHEX2num, iHEX3num;
	
	HexDigit Digit0(HEX0, iHEX0num[3:0]);
	HexDigit Digit1(HEX1, iHEX1num[3:0]);
	HexDigit Digit2(HEX2, iHEX2num[3:0]);
	HexDigit Digit3(HEX3, iHEX3num[3:0]);

	always @(num) begin
		iHEX0num <= num%10;
		iHEX1num <= (num)/10 % 10;
		iHEX2num <= (num)/100 % 10;
		iHEX3num <= (num)/1000 % 10;
	end
endmodule
