/*
 * Mutex for up to eight contenders
 * Essentially a priority decoder
 */

module mutex8bit(CLOCK, in, out);
   input CLOCK;
   input [7:0]  in;
   reg [7:0]    out; // granted lines
   output [7:0] out;

   initial begin
      out <= 8'b0;
   end

   always @(posedge CLOCK) begin
      // cases where we can reassign
      if ((out == 8'b00000000) |
          (out == 8'b00000001 & ~in[0])| 
          (out == 8'b00000010 & ~in[1]) |
          (out == 8'b00000100 & ~in[2]) |
          (out == 8'b00001000 & ~in[3]) |
          (out == 8'b00010000 & ~in[4]) |
          (out == 8'b00100000 & ~in[5]) |
          (out == 8'b01000000 & ~in[6]) |
          (out == 8'b10000000 & ~in[7]))
        begin
           if (in[0]) out <= 8'b00000001;
           else if (in[1]) out <= 8'b00000010;
           else if (in[2]) out <= 8'b00000100;
           else if (in[3]) out <= 8'b00001000;
           else if (in[4]) out <= 8'b00010000;
           else if (in[5]) out <= 8'b00100000;
           else if (in[6]) out <= 8'b01000000;
           else if (in[7]) out <= 8'b10000000;
           else out <= 8'b00000000;
        end
   end // always @ (posedge CLOCK)
endmodule // mutex8bit
